import { NgModule, ModuleWithProviders } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TranslateModule } from '@ngx-translate/core';

import { AccountsStoreModule } from './accounts-store.module';
import { MatButtonModule } from '@angular/material/button';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';

import { FuseSharedModule } from 'src/@fuse/shared.module';
import { AccountsRoutingPageModule } from './accounts-routing.page.module';

import { COMPONENTS } from './component';
import { SERVICES } from './service';

@NgModule({
  imports: [AccountsStoreModule],
  exports: []
})
export class AccountsRootModule {}

@NgModule({
  imports: [
    CommonModule,
    TranslateModule,
    AccountsRoutingPageModule,

    MatButtonModule,
    MatCheckboxModule,
    MatFormFieldModule,
    MatIconModule,
    MatInputModule,

    FuseSharedModule

    // SharedModule,
  ],
  declarations: [...COMPONENTS],
  exports: [...COMPONENTS]
})
export class AccountsModule {
  public static forRoot(): ModuleWithProviders<AccountsRootModule> {
    return {
      ngModule: AccountsRootModule,
      providers: [...SERVICES]
    };
  }
}
