import { Injectable, Inject } from '@angular/core';
import { HttpClient } from '@angular/common/http';

import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';

import { CookieService } from 'ngx-cookie-service';
import { environment } from '../../../../environments/environment';
import { User } from '../../../../shared/user/model/user.model';
import { API_BASE_URL } from 'src/shared/common/type/injection-token.type';

@Injectable()
export class AccountsService {
  public constructor(
    private httpClient: HttpClient,
    private cookieService: CookieService,
    @Inject(API_BASE_URL) private apiBaseUrl: string
  ) {}

  // public authenticate(oauthType: string, params?: Map<string, string>) {
  //   const query = this.getQueryParams(params);

  //   const externalUrl = new URL(`${environment.oauth[oauthType].authenticateURL}?${query}`);

  //   window.open(externalUrl.href, '_self');
  // }

  // public authenticateOneall(oauthType: string, params?: Map<string, string>) {
  //   const callbackUri = `${environment.oauth.oneall.callbackURL}?${this.getQueryParams(params)}`;

  //   let query = '';
  //   query += `service=social_login`;
  //   query += `&callback_uri=${callbackUri}`;

  //   const externalUrl = new URL(`${environment.oauth.oneall.authenticateURL}/${oauthType}/?${query}`);

  //   window.open(externalUrl.href, '_self');
  // }

  protected getQueryParams(params?: Map<string, string>): string {
    let query = '';

    if (!params || 0 === params.size) {
      return query;
    }

    params.forEach((value, key) => {
      if ('' !== query) {
        query += '&';
      }
      query += `${key}=${value}`;
    });

    return query;
  }

  public login(username: string, password: string): Observable<User> {
    const model = {
      username,
      password
    };

    return this.httpClient.post<User>(`${this.apiBaseUrl}/auth/signin`, model);
  }
}
